package com.buenodev.tests.debtoid_pruebas;

/*
/Aquesta obra esta subjecta a una licencia de Reconeixement-NoComercial-SenseObraDerivada 3.0 Espanya de Creative Commons
/
/
*/
/*
Adaptador per carregar les dades dels contactes que tenen algun deute.
 */

import android.app.Activity;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.net.Uri;
import android.preference.PreferenceManager;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import java.util.ArrayList;


public class AdapterContactPagament extends ArrayAdapter<ContactMet> {

    Activity context;
    ArrayList<ContactMet> listaContactos;


    public AdapterContactPagament(Activity context, ArrayList<ContactMet> listaContactos) {
        super(context, R.layout.layout_adapterdeutes, listaContactos);
        this.context = context;
        this.listaContactos = listaContactos;
    }

    public View getView(int position, View convertView, ViewGroup parent) {


        View item = convertView;
        item = context.getLayoutInflater().inflate(R.layout.layout_adapterdeutes, null);
        ContactMet c = listaContactos.get(position);


        ImageView img = (ImageView) item.findViewById(R.id.imagen);
        TextView nom = (TextView) item.findViewById(R.id.texto);
        TextView qty = (TextView) item.findViewById(R.id.Quantitat);

        nom.setText(c.getName(c.getIdContact(), context));
        img.setImageBitmap(c.getPhoto(c.getIdContact(), context));

        DebtoidDBOpenHelper usdbh =
                new DebtoidDBOpenHelper(context, "DBDebtoid", null, 1);

        final SQLiteDatabase db = usdbh.getWritableDatabase();
        String quanty = null;

        SharedPreferences pref =
                PreferenceManager.getDefaultSharedPreferences(getContext());

        String  money = pref.getString("opciomoneda", "");
        switch (money){
            case "":
                money = "€";
                break;
            case "1":
                money = "€";
                break;
            case "2":
                money = "$";
                break;
            case "3":
                money = "£";
                break;
        }

        String  ordre = pref.getString("ordreper", "");
        switch (ordre){
            case "":
                ordre = "Quantitat ASC";
                break;
            case "1":
                ordre = "Quantitat ASC";
                break;
            case "2":
                ordre = "Quantitat DESC";
                break;
            case "3":
                ordre = "Data_inici ASC";
                break;
            case "4":
                ordre = "Data_inici DESC";
                break;
        }

        Cursor quantity = DebtoidDBOpenHelper.getQtyPagament(db, Uri.parse(c.getIdContact()), ordre);
        for (quantity.moveToFirst(); !quantity.isAfterLast(); quantity.moveToNext()) {
            quanty = quantity.getString(0);

        }


        qty.setText("El pagament pendent és de: " + quanty.toString() + " " + money);

        return (item);
    }


}