package com.buenodev.tests.debtoid_pruebas;

/*
/Aquesta obra esta subjecta a una licencia de Reconeixement-NoComercial-SenseObraDerivada 3.0 Espanya de Creative Commons
/
/
*/
/*
Activity per a editar els deutes relatius a cobraments. Permet guardar canvis, saldar el deute i n
otificar a l'usuari.
 */
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.preference.PreferenceManager;
import android.support.v4.app.FragmentManager;
import android.support.v7.app.ActionBarActivity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;


public class CobramentEdit extends ActionBarActivity {
    TextView textContact;
    ImageView imageContact;
    EditText TextConcepte;
    EditText TextQuantitat;
    Button savebutton;
    Button notibutton;
    Button paybutton;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_cobrament_edit);

        textContact = (TextView)findViewById(R.id.textContact);
        imageContact = (ImageView)findViewById(R.id.imageContact);
        TextConcepte = (EditText)findViewById(R.id.TextConcepte);
        TextQuantitat = (EditText)findViewById(R.id.TextQuantitat);
        savebutton = (Button)findViewById(R.id.Savebutton);
        notibutton = (Button)findViewById(R.id.Notibutton);
        paybutton = (Button)findViewById(R.id.Paybutton);

        Bundle bundle = this.getIntent().getExtras();
        String Id_Deute= bundle.getString("ID");
        String ID_Usr = bundle.getString("IDUsr");

        final Context context= this.getApplicationContext();
        String Deute = null;
        DebtoidDBOpenHelper usdbh =
                new DebtoidDBOpenHelper(this, "DBDebtoid", null, 1);
        final SQLiteDatabase db = usdbh.getWritableDatabase();
        String Usuari = null;
        Cursor c = DebtoidDBOpenHelper.getURiUserbyID(db,ID_Usr);
        c.moveToFirst();
        Usuari = c.getString(0);
       textContact.setText(ContactMet.getName(Usuari, context));
        imageContact.setImageBitmap(ContactMet.getPhoto(Usuari, context));


        String ID_Deute = null;

        SharedPreferences pref =
                PreferenceManager.getDefaultSharedPreferences(this);
        String  ordre = pref.getString("opciordre", "");
        String ordre2 = ordre;
        switch (ordre){
            case "":
                ordre = "SUM(Quantitat) ASC";
                ordre2 = "Quantitat ASC";
                break;
            case "1":
                ordre = "SUM(Quantitat) ASC";
                ordre2 = "Quantitat ASC";
                break;
            case "2":
                ordre = "SUM(Quantitat) DESC";
                ordre2 = "Quantitat DESC";
                break;
            case "3":
                ordre = "Data_inici ASC";
                ordre2 = "Data_inici  ASC";
                break;
            case "4":
                ordre = "Data_inici DESC";
                ordre2 = "Data_inici  DESC";
                break;
        }
        Cursor cc = DebtoidDBOpenHelper.getDeutes1a1(db, 1, ID_Usr, ordre2);
        cc.moveToPosition(Integer.parseInt(Id_Deute));
        ID_Deute = cc.getString(0);


       Cursor cccc = DebtoidDBOpenHelper.getQuantitatD1a1(db, ID_Deute);
        cccc.moveToFirst();
        TextQuantitat.setText(cccc.getString(0));

        Cursor ccc = DebtoidDBOpenHelper.getConcepteD1a1(db, ID_Deute);
        ccc.moveToFirst();

        TextConcepte.setText(ccc.getString(0));




        final String finalDeute = ID_Deute;


        savebutton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                if ( TextConcepte.getText().toString().isEmpty() || TextQuantitat.getText().toString().isEmpty()  ) {
                    Toast toast1 =

                            Toast.makeText(getApplicationContext(),
                                    "Has d'omplir totes les dades ",
                                    Toast.LENGTH_LONG);
                    toast1.show();

                } else {

                final String[] Dades = {
                        TextConcepte.getText().toString(),
                        TextQuantitat.getText().toString(),
                        "1"
                };

                if (Float.compare(Float.parseFloat(Dades[1]), Float.parseFloat("0"))==0) {
                    Toast.makeText(context, "No existeixen els deutes amb valor 0",
                            Toast.LENGTH_SHORT).show();
                }else{



                    AlertDialog.Builder alertDialog = new AlertDialog.Builder(CobramentEdit.this);

                    // Setting Dialog Title
                    alertDialog.setTitle("Confirmar actualització");

                    // Setting Dialog Message
                    alertDialog.setMessage("Vols actualitzar el deute?");

                    // Setting Positive "Yes" Button
                    alertDialog.setPositiveButton("Sí", new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog,int which) {


                            DebtoidDBOpenHelper.updateDeute1a1(db, Dades, finalDeute);

                            Intent intent =
                                    new Intent(CobramentEdit.this, Cobraments_Activity.class)
                                            .addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                            startActivity(intent);
                            finish();


                        }
                    });

                    // Setting Negative "NO" Button
                    alertDialog.setNegativeButton("No", new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int which) {
                            // Write your code here to invoke NO event
                            Toast.makeText(getApplicationContext(), "No s'ha actualitzat el deute", Toast.LENGTH_SHORT).show();
                            dialog.cancel();
                        }
                    });

                    alertDialog.show();

                }}

            }


        });



        paybutton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {


                if (TextConcepte.getText().toString().isEmpty() || TextQuantitat.getText().toString().isEmpty()) {
                    Toast toast1 =
                            Toast.makeText(getApplicationContext(),
                                    "Has d'omplir totes les dades ",
                                    Toast.LENGTH_LONG);
                    toast1.show();
                } else {


                    AlertDialog.Builder alertDialog = new AlertDialog.Builder(CobramentEdit.this);

                    alertDialog.setTitle("Confirmar pagament");

                    alertDialog.setMessage("Confirmar el pagament");


                    alertDialog.setPositiveButton("Sí", new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int which) {

                            String[] Dades = {
                                    TextConcepte.getText().toString(),
                                    TextQuantitat.getText().toString(),
                                    "2"
                            };

                            DebtoidDBOpenHelper.updateDeute1a1(db, Dades, finalDeute);

                            Intent intent =
                                    new Intent(CobramentEdit.this, Cobraments_Activity.class)
                                            .addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                            startActivity(intent);

                            finish();

                        }
                    });

                    alertDialog.setNegativeButton("NO", new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int which) {

                            Toast.makeText(getApplicationContext(), "No s'ha acceptat", Toast.LENGTH_SHORT).show();
                            dialog.cancel();
                        }
                    });

                    alertDialog.show();

                }


            }});





            notibutton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                PackageManager pm=getPackageManager();
                try {

                    Intent waIntent = new Intent(Intent.ACTION_SEND);
                    waIntent.setType("text/plain");
                    String text = "---Enviat des de DEBTOID--- Recordatori de deuta:" +
                            " " + TextQuantitat.getText() + " en concepte de " +
                            TextConcepte.getText();

                    PackageInfo info=pm.getPackageInfo("com.whatsapp", PackageManager.GET_META_DATA);

                    waIntent.setPackage("com.whatsapp");

                    waIntent.putExtra(Intent.EXTRA_TEXT, text);
                    startActivity(Intent.createChooser(waIntent, "Share with"));

                } catch (PackageManager.NameNotFoundException e) {
                    Toast.makeText(context, "WhatsApp no Instal-lat", Toast.LENGTH_SHORT)
                            .show();
                }

            }





        });





    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {

        getMenuInflater().inflate(R.menu.menu_cobrament_edit, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
       // if (id == R.id.action_settings) {
            return true;
       // }

        //return super.onOptionsItemSelected(item);
    }
}
