package com.buenodev.tests.debtoid_pruebas;

/*
/Aquesta obra esta subjecta a una licencia de Reconeixement-NoComercial-SenseObraDerivada 3.0 Espanya de Creative Commons
/
/
*/
/*
Activity amb els cobraments 1a1 amb més detall per cada usuari
 */
import android.annotation.TargetApi;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.net.Uri;
import android.os.Build;
import android.preference.PreferenceManager;
import android.support.v7.app.ActionBarActivity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;

import java.util.ArrayList;


public class CobramentListView extends ActionBarActivity {

    private ImageView img;
    private TextView TextContact;
    private TextView TextTotal;
    private String Quanty = null;
    ListView listView;
    ArrayList<ContactMet1a1> listaContactos;
    AdapterContact1a1 adapter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_cobramentlist);

        listView = (ListView) findViewById(R.id.listView);
        listaContactos = new ArrayList<ContactMet1a1>();
        img = (ImageView)findViewById(R.id.imageContact);
        TextContact = (TextView)findViewById(R.id.textView);
        TextTotal = (TextView)findViewById(R.id.TextTotal);

        Bundle bundle = this.getIntent().getExtras();
        Integer Id_Usuari = Integer.parseInt(bundle.getString("ID"));
        String Usuari = null;
        DebtoidDBOpenHelper usdbh =
                new DebtoidDBOpenHelper(this, "DBDebtoid", null, 1);
        final SQLiteDatabase db = usdbh.getWritableDatabase();
        SharedPreferences pref =
                PreferenceManager.getDefaultSharedPreferences(this);
        String  ordre = pref.getString("opciordre", "");
        String ordre2 = ordre;
        switch (ordre){
            case "":
                ordre = "SUM(Quantitat) ASC";
                ordre2 = "Quantitat ASC";
                break;
            case "1":
                ordre = "SUM(Quantitat) ASC";
                ordre2 = "Quantitat ASC";
                break;
            case "2":
                ordre = "SUM(Quantitat) DESC";
                ordre2 = "Quantitat DESC";
                break;
            case "3":
                ordre = "Data_inici ASC";
                ordre2 = "Data_inici  ASC";
                break;
            case "4":
                ordre = "Data_inici DESC";
                ordre2 = "Data_inici  DESC";
                break;
        }

        Cursor c = DebtoidDBOpenHelper.getDadesCobrament(db, ordre);
        c.moveToPosition(Id_Usuari);
        Usuari = c.getString(0);        //Uri de l'usuari, per extreure les dades
        String UsuariIndex = null;
        Cursor cc = DebtoidDBOpenHelper.getIdUser(db, Uri.parse(Usuari));
        cc.moveToFirst();
        UsuariIndex = cc.getString(0);      //ID de l'usuari
        final String finalUsuariIndex = UsuariIndex; //Variable de tipus final, per utilitzar en métode static

       final Cursor cur = DebtoidDBOpenHelper.getDeutes1a1(db, 1,UsuariIndex, ordre2);      //Obtinc les dades del deute
            //Carrego les dades al listview - Cobraments per l'usuari escollit
        for(cur.moveToFirst(); !cur.isAfterLast(); cur.moveToNext()) {
            listaContactos.add(new ContactMet1a1(cur.getString(0)));
        }
        Context context= this.getApplicationContext();

        //Estableixo les dades de l'usuari
        TextContact.setText(ContactMet.getName(Usuari, context));
        img.setImageBitmap(ContactMet.getPhoto(Usuari, context));
        Cursor quantity = DebtoidDBOpenHelper.getQty(db, Uri.parse(Usuari), ordre);
        for(quantity.moveToFirst(); !quantity.isAfterLast(); quantity.moveToNext()) {
            Quanty = quantity.getString(0);
        }
        TextTotal.setText("El deute es de: " + Quanty.toString());

        adapter = new AdapterContact1a1(this, listaContactos);

        listView.setAdapter(adapter);

        adapter.notifyDataSetChanged();
            //Listener per escollir el deute concret de l'usuari
        listView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @TargetApi(Build.VERSION_CODES.JELLY_BEAN)
            public void onItemClick(AdapterView<?> parent, View view,
                                    int position, long id) {

                Integer posicion = position;
                String posicion2 = posicion.toString();

                Bundle b = new Bundle();
                b.putString("ID", posicion2);
                b.putString("IDUsr",finalUsuariIndex);

                //Creamos el Intent
                Intent intent =
                        new Intent(CobramentListView.this, CobramentEdit.class).addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                //Añadimos la información al intent
                intent.putExtras(b);
                startActivity(intent, b);


            }
        });

    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_cobrament_edit, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
       // if (id == R.id.action_settings) {
            return true;
       // }

       // return super.onOptionsItemSelected(item);
    }
}
