package com.buenodev.tests.debtoid_pruebas;

/*
/Aquesta obra esta subjecta a una licencia de Reconeixement-NoComercial-SenseObraDerivada 3.0 Espanya de Creative Commons
/
/
*/
/*
Activity per a gestionar els cobraments 1a1
 */
import android.annotation.TargetApi;
import android.content.Intent;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Build;
import android.preference.PreferenceManager;
import android.support.v7.app.ActionBarActivity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.ListView;

import java.util.ArrayList;


public class Cobraments_Activity extends ActionBarActivity {
    private Button nouCobrament;
    ListView listView;
    ArrayList<ContactMet> listaContactos;
    AdapterContact adapter;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_cobraments);
        listView = (ListView) findViewById(R.id.listView);
        listaContactos = new ArrayList<ContactMet>();

        //Obro la base de dades 'DBUsuarios' en mode escritura
        final DebtoidDBOpenHelper usdbh =
                new DebtoidDBOpenHelper(this, "DBDebtoid", null, 1);

        final SQLiteDatabase db = usdbh.getWritableDatabase();

        SharedPreferences pref =
                PreferenceManager.getDefaultSharedPreferences(this);
        String  ordre = pref.getString("opciordre", "");
        switch (ordre){
            case "":
                ordre = "SUM(d.Quantitat) ASC";
                break;
            case "1":
                ordre = "SUM(d.Quantitat) ASC";
                break;
            case "2":
                ordre = "SUM(d.Quantitat) DESC";
                break;
            case "3":
                ordre = "d.Data_inici ASC";
                break;
            case "4":
                ordre = "d.Data_inici DESC";
                break;
        }





        //Carrego les dades dels cobraments al listview, mitjanant un adapter
        final Cursor cur = DebtoidDBOpenHelper.getDadesCobrament(db, ordre);

        for(cur.moveToFirst(); !cur.isAfterLast(); cur.moveToNext()) {
            listaContactos.add(new ContactMet(cur.getString(0)));
        }

        adapter = new AdapterContact(this, listaContactos);
        listView.setAdapter(adapter);

        adapter.notifyDataSetChanged();

        nouCobrament = (Button)findViewById(R.id.NouCobramentButton);
        //But per fer un nou cobrament
        nouCobrament.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent =
                        new Intent(Cobraments_Activity.this, NouCobramentActivity.class)
                                .addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);


                startActivity(intent);
                finish();


            }
        });




        //Listener per escollir un item de la llista i iniciar una nova activity
        listView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @TargetApi(Build.VERSION_CODES.JELLY_BEAN)
            public void onItemClick(AdapterView<?> parent, View view,
                                    int position, long id) {

                Integer posicion = position;
                String posicion2 = posicion.toString();

                Bundle b = new Bundle();
                b.putString("ID", posicion2);


                Intent intent =
                        new Intent(Cobraments_Activity.this, CobramentListView.class).addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);

                intent.putExtras(b);
                startActivity(intent,b);
                finish();


            }
        });

    }






    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_cobraments, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
      //  if (id == R.id.action_settings) {
            return true;
      //  }

      //  return super.onOptionsItemSelected(item);
    }
}
