package com.buenodev.tests.debtoid_pruebas;
/*
/Aquesta obra esta subjecta a una licencia de Reconeixement-NoComercial-SenseObraDerivada 3.0 Espanya de Creative Commons
/
/
*/



/*
Aquesta classe cont l'estructura de l'array que utilitzem per a extreure les dades dels contactes.
 */
        import android.content.ContentResolver;
        import android.content.ContentUris;
        import android.content.Context;
        import android.database.Cursor;
        import android.graphics.Bitmap;
        import android.graphics.BitmapFactory;
        import android.net.Uri;
        import android.provider.ContactsContract;
        import java.io.IOException;
        import java.io.InputStream;


public class ContactGrup {


    String IdContact;



    public ContactGrup(String IdContact) {
        super();
        this.IdContact = IdContact;

    }
    public String getIdContact() {
        return IdContact.toString();
    }

    public static String getName(String uri, Context context) {


        String name = null;

        ContentResolver contentResolver = context.getContentResolver();

        Cursor c = contentResolver.query(
                Uri.parse(uri),
                new String[]{ContactsContract.Contacts.DISPLAY_NAME},
                null,
                null,
                null);

        if(c.moveToFirst()){
            name = c.getString(0);
        }


        c.close();

        return name;
    }

    public static Bitmap getPhoto(String uri, Context context) {

        Bitmap photo = null;
        String id = null;
        ContentResolver contentResolver = context.getContentResolver();
        /************* CONSULTA ************/
        Cursor contactCursor = contentResolver.query(
                Uri.parse(uri),
                new String[]{ContactsContract.Contacts._ID},
                null,
                null,
                null);

        if (contactCursor.moveToFirst()) {
            id = contactCursor.getString(0);
        }
        contactCursor.close();


        try {
            Uri contactUri = ContentUris.withAppendedId(
                    ContactsContract.Contacts.CONTENT_URI,
                    Long.parseLong(id));

            InputStream input = ContactsContract.Contacts.openContactPhotoInputStream(
                    contentResolver,
                    contactUri);

            if (input != null) {

                if (input.toString()=="") {
                    input.close();
                }else {

                    photo = BitmapFactory.decodeStream(input);
                    input.close();
                }
            }

        } catch (IOException iox) { }

        return photo;
    }



    public static String getPhone(String uri, Context context) {

        String id = null;
        String phone = null;
        ContentResolver contentResolver = context.getContentResolver();

        Cursor contactCursor = contentResolver.query(
                Uri.parse(uri), new String[]{ContactsContract.Contacts._ID},
                null, null, null);


        if (contactCursor.moveToFirst()) {
            id = contactCursor.getString(0);
        }
        contactCursor.close();


        String selectionArgs =
                ContactsContract.CommonDataKinds.Phone.CONTACT_ID + " = ? AND " +
                        ContactsContract.CommonDataKinds.Phone.TYPE + "= " +
                        ContactsContract.CommonDataKinds.Phone.TYPE_MOBILE;


        Cursor phoneCursor = contentResolver.query(
                ContactsContract.CommonDataKinds.Phone.CONTENT_URI,
                new String[]{ContactsContract.CommonDataKinds.Phone.NUMBER},
                selectionArgs
                ,
                new String[]{id},
                null
        );
        if (phoneCursor.moveToFirst()) {
            phone = phoneCursor.getString(0);
        }
        phoneCursor.close();

        return phone;
    }

}
