package com.buenodev.tests.debtoid_pruebas;

/*
/Aquesta obra esta subjecta a una licencia de Reconeixement-NoComercial-SenseObraDerivada 3.0 Espanya de Creative Commons
/
/
*/
/*
En aquesta classe trobem els métodes i funcions relatius a la base de dades.
 */
import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteDatabase.CursorFactory;
import android.database.sqlite.SQLiteOpenHelper;
import android.net.Uri;
import android.provider.BaseColumns;
import android.view.Gravity;
import android.widget.Toast;

import java.text.SimpleDateFormat;
import java.util.Date;

//Aquesta classe exté de la classe d'Android SQLiteOpenHelper per poder utilitzar SQLite
public class DebtoidDBOpenHelper extends SQLiteOpenHelper {


    //Definició de taula Deute1a1
    private static final String TABLE_Deute1a1 = "Deute1a1";
    public static final class Deute1a1 implements BaseColumns {//
        private Deute1a1() {}
        public static final String ID_Deute1a1 = "_Id";
        public static final String Deutor = "deutor";
        public static final String ID_Degut = "Id_degut";
        public static final String Data_inici = "Data_inici";
        public static final String Data_Fi = "Data_Fi";
        public static final String Quantitat = "Quantitat";
        public static final String Concepte = "Concepte";
        public static final String Estat = "Estat";
    }

    //Definició de taula DeuteGrups
    private static final String TABLE_DeuteGrup = "DeuteGrup";
    public static final class DeuteGrup implements BaseColumns {
        private DeuteGrup() {}
        public static final String ID_DeuteGrups = "_Id";
        public static final String Id_Grup = "Id_Grup";
        public static final String Id_Deutor = "Id_Deutor";
        public static final String Quantitat = "Quantitat";
        public static final String  Estat = "Estat";

    }

    //Definició de taula Grups
    private static final String TABLE_Grups = "Grups";
    public static final class Grups implements BaseColumns {
        private Grups() {}
        public static final String ID_Grup = "_Id";
        public static final String NOM = "Nom";
        public static final String Concepte = "Concepte";
        public static final String Estat = "estat";
        public static final String Total = "total";
        public static final String Data_Inici = "Data_Inici";
        public static final String Data_Fi = "Data_Fi";
    }

    //Definició de taula Users
    private static final  String TABLE_Usuaris = "Users";
    public static final class Users implements BaseColumns {
        private Users() {}
        public static final String ID_USER = "_Id";
        public static final String ID_Contact = "Id_contact";
    }


    // Sentencies per a la creació de les taules

    private static final String DEUTE1A1_TABLE_CREATE = "create table " + TABLE_Deute1a1
            + " (" + Deute1a1.ID_Deute1a1 + " INTEGER PRIMARY KEY AUTOINCREMENT, "
            + Deute1a1.Deutor + " INTEGER NOT NULL, " + Deute1a1.ID_Degut + " INTEGER NOT NULL, "
            + Deute1a1.Data_inici + " TEXT NOT NULL, " + Deute1a1.Data_Fi + " TEXT, " +
            Deute1a1.Quantitat + " REAL NOT NULL,  " + Deute1a1.Concepte + " TEXT, " +
            Deute1a1.Estat + " INTEGER NOT NULL );";

    private static final String DEUTEGRUPS_TABLE_CREATE = "create table " + TABLE_DeuteGrup
            + "(" + DeuteGrup.ID_DeuteGrups + " INTEGER PRIMARY KEY AUTOINCREMENT, " +
            DeuteGrup.Id_Grup +  " INTEGER NOT NULL, " + DeuteGrup.Id_Deutor +
            " INTEGER NOT NULL, " + DeuteGrup.Quantitat + " REAL NOT NULL, " + DeuteGrup.Estat +
            " INTEGER NOT NULL );";

    private static final String GRUPS_TABLE_CREATE = "create table " + TABLE_Grups
            + "(" + Grups.ID_Grup + " INTEGER PRIMARY KEY AUTOINCREMENT, " + Grups.NOM +
            " text not null, " + Grups.Concepte + " TEXT, "  +
            Grups.Estat + " INTEGER not null, " + Grups.Total + " TEXT NOT NULL, "  + Grups.Data_Inici + " TEXT NOT NULL, " +
            Grups.Data_Fi + " TEXT );";

    private static final String USUARIS_TABLE_CREATE = "create table " + TABLE_Usuaris
            + "(" + Users.ID_USER + " INTEGER PRIMARY KEY AUTOINCREMENT, " +
            Users.ID_Contact + " TEXT NOT NULL);";





    public DebtoidDBOpenHelper(Context contexto, String nombre,
                               CursorFactory factory, int version) {
        super(contexto, nombre, factory, version);

    }

    @Override
    public void onCreate(SQLiteDatabase db) {
        //s'executa la senténcia per crear les taules

        db.execSQL(DEUTE1A1_TABLE_CREATE);
        db.execSQL(DEUTEGRUPS_TABLE_CREATE);
        db.execSQL(GRUPS_TABLE_CREATE);
        db.execSQL(USUARIS_TABLE_CREATE);

    }

    @Override
    public void onUpgrade(SQLiteDatabase db, int versionAnterior, int versionNueva) {

        //
        db.execSQL("DROP TABLE IF EXISTS Users");
        db.execSQL("DROP TABLE IF EXISTS Deute1a1");
        db.execSQL("DROP TABLE IF EXISTS Grups");
        db.execSQL("DROP TABLE IF EXISTS DeuteGrup");

        db.execSQL(DEUTE1A1_TABLE_CREATE);
        db.execSQL(DEUTEGRUPS_TABLE_CREATE);
        db.execSQL(GRUPS_TABLE_CREATE);
        db.execSQL(USUARIS_TABLE_CREATE);

    }



    //Consultes utilitzades per l'aplicació.  Es separen per respectar el model MVC.



    public static String insertarGrups(SQLiteDatabase db,String nom, String concepte, String Total ) {  //Inserció d'un grup

        SimpleDateFormat s = new SimpleDateFormat("dd-MM-yyyy hh:mm a");
        String formatData = s.format(new Date());
        ContentValues nuevoRegistro = new ContentValues();
        nuevoRegistro.put(Grups.NOM,nom);
        nuevoRegistro.put(Grups.Concepte,concepte);
        nuevoRegistro.put(Grups.Total,Total);
        nuevoRegistro.put(Grups.Data_Inici, formatData.toString());
        nuevoRegistro.put(Grups.Estat, "1");
        long idgrup =db.insert(TABLE_Grups, null, nuevoRegistro);


        return String.valueOf(idgrup);

    }

    public static void insertDeuteGrup(SQLiteDatabase db, String IdGrup, String Iddeutor, String quantitat) { //Inserció del deute d'un usuari relacionat amb el seu grup

        ContentValues nuevoRegistro = new ContentValues();
        nuevoRegistro.put(DeuteGrup.Id_Grup,IdGrup);
        nuevoRegistro.put(DeuteGrup.Id_Deutor,Iddeutor);
        nuevoRegistro.put(DeuteGrup.Quantitat, Double.parseDouble(quantitat));
        nuevoRegistro.put(DeuteGrup.Estat, "1");


        db.insert(TABLE_DeuteGrup, null, nuevoRegistro);

    }




    public static void insertarUsuari(SQLiteDatabase db, Uri contactUri) {      //Inserció d'un contacte emmagatzemant la URI del mateix

        Cursor c = db.rawQuery("SELECT COUNT(Id_contact) FROM Users WHERE Id_contact = '"
                + contactUri.toString() + "'", null);
        c.moveToFirst();
        int count= c.getInt(0);
        c.close();
        if (count==0) {
            ContentValues nuevoRegistro = new ContentValues();
            nuevoRegistro.put(Users.ID_Contact, contactUri.toString());
            db.insert(TABLE_Usuaris, null, nuevoRegistro);
        }

    }


    //Per a deutes que l'usuari deu, deutor=1, si li deuen, deutor =0, Estat = 1 per pendent de pagar, 2 per pagat
    public static void insertDeute1a1(SQLiteDatabase db, int deutor, Integer contact, String concepte, String quantitat) {      //Inserció d'un deute, ja sigui cobrament o pagament

        SimpleDateFormat s = new SimpleDateFormat("dd-MM-yyyy hh:mm a");
        String formatData = s.format(new Date());
        ContentValues nuevoRegistro = new ContentValues();
        nuevoRegistro.put(Deute1a1.Deutor,deutor);
        nuevoRegistro.put(Deute1a1.ID_Degut,contact);
        nuevoRegistro.put(Deute1a1.Data_inici, formatData.toString());
        nuevoRegistro.put(Deute1a1.Data_Fi,"" );
        nuevoRegistro.put(Deute1a1.Concepte,concepte);
        nuevoRegistro.put(Deute1a1.Quantitat, Double.parseDouble(quantitat));
        nuevoRegistro.put(Deute1a1.Estat, "1");


        db.insert(TABLE_Deute1a1, null, nuevoRegistro);

    }

    public static Cursor getNomGrup(SQLiteDatabase db, String IDGrup) {             //Consulta que retorna el nom d'un grup

        Cursor c = db.rawQuery("SELECT nom FROM Grups WHERE _Id="+IDGrup,null);
        return c;
    }
    public static Cursor getConcepteGrup(SQLiteDatabase db, String IDGrup) {        //Consulta que retorna el concepte d'un grup

        Cursor c = db.rawQuery("SELECT concepte FROM Grups WHERE _Id="+IDGrup,null);
        return c;
    }

    public static Cursor getQuantitatGrups(SQLiteDatabase db, String IDGrup) {      //Consulta que retorna la quantitat que es deu d'un grup

        Cursor c = db.rawQuery("SELECT Total FROM Grups WHERE _Id =" + IDGrup +
                " AND Estat=1", null);
        return c;
    }

    public static Cursor  getcontactsperDeuteGrup(SQLiteDatabase db, String IDGrup) {       //Consulta que retorna els contactes pendents de pagar d'un grup



        Cursor c = db.rawQuery("SELECT _Id, Id_Grup, Id_Deutor, Quantitat FROM DeuteGrup WHERE Estat=1 AND Id_Grup= " + IDGrup
     , null);
        return c;
    }






    public static Cursor getContactUris(SQLiteDatabase db) {            //Métode per proves

       Cursor c = db.rawQuery("SELECT  Id_contact FROM Users", null);
        return c;
    }

    public static Cursor getIdUser(SQLiteDatabase db, Uri contactUri) {     //Métode per trobar l'Id d'un usuari a partir de la seva URI

        Cursor c = db.rawQuery("SELECT  _Id FROM Users WHERE Id_contact = '" + contactUri +"'", null);
        return c;
    }

    public static Cursor getURiUserbyID(SQLiteDatabase db, String IDUser) {     //Métode per trobar la URI d'un usuari a partir del seu ID

        Cursor c = db.rawQuery("SELECT  Id_contact FROM Users WHERE _Id = '" + IDUser +"'", null);
        return c;
    }



    public static Cursor getDadesCobrament(SQLiteDatabase db, String ordre) {       //Métode que torna els IDs dels usuaris d'un cobrament



        Cursor c = db.rawQuery("SELECT  Id_contact FROM Users u, Deute1a1 d WHERE u._Id = d.Id_degut " +
                "AND d.Estat = 1 AND d.deutor=1 GROUP by u.Id_contact ORDER BY "+ ordre , null);

        return c;
    }

    public static Cursor getDadesHCobrament(SQLiteDatabase db) {                //Métode que torna les dades  dels usuaris d'un cobrament per a l'históric



        Cursor c = db.rawQuery("SELECT * FROM Deute1a1 WHERE Deutor = 2 AND  Estat = 2 ORDER BY Data_Fi DESC", null);

        return c;
    }
    public static Cursor getDadesHPagament(SQLiteDatabase db) {             //Métode que torna els IDs dels usuaris d'un pagament per a l'históric



        Cursor c = db.rawQuery("SELECT * FROM Deute1a1 WHERE Deutor = 1 AND  Estat = 2 ORDER BY Data_Fi DESC", null);

        return c;
    }

    public static Cursor getDeuteGrupId(SQLiteDatabase db, String Id_grup, String ordre) {      //Métode per a trobar les dades d'un grup segons el seu Id



        Cursor c = db.rawQuery("SELECT  * FROM DeuteGrup WHERE Id_Grup = " + Id_grup +
                " ORDER BY "+ ordre , null);

        return c;
    }


    public static Cursor getDadesCobramentGrups(SQLiteDatabase db, String ordre) {      //Métode per extreure dades de cobrament de grups actius



        Cursor c = db.rawQuery("SELECT _Id, Nom, Concepte, Total, Data_Inici FROM Grups  WHERE Estat=1  ORDER BY   "+ ordre , null);

        return c;
    }

    public static Cursor getDadesGrups(SQLiteDatabase db, String ordre) {           //Métode per extreure dades de cobrament de grups actius. Igual a l'anterior



        Cursor c = db.rawQuery("SELECT _Id, Nom, Concepte, Data_Inici, Total FROM Grups WHERE Grups.estat=1  ORDER BY   "+ ordre , null);



        return c;
    }


    public static Cursor getDadesPagament(SQLiteDatabase db, String ordre) {        //Métode per a extreure les dades dels pagaments



        Cursor c = db.rawQuery("SELECT  Id_contact FROM Users u, Deute1a1 d WHERE u._Id = d.Id_degut " +
                "AND d.Estat = 1 AND d.deutor=2 GROUP by u.Id_contact ORDER BY "+ ordre , null);

        return c;
    }

    public static Cursor getQty(SQLiteDatabase db, Uri contactUri, String ordre) {      //Métode per a trobar la quantitat total deguda per un usuari (sense comptar grups)

        String id_contact=null;
        Cursor id_cursor;
        id_cursor=getIdUser(db,contactUri);

        for(id_cursor.moveToFirst(); !id_cursor.isAfterLast(); id_cursor.moveToNext()) {
            id_contact = id_cursor.getString(0);

        }


        Cursor c = db.rawQuery("SELECT  SUM(Quantitat) FROM Deute1a1 WHERE id_degut = " + id_contact +
                " AND deutor=1 AND Estat=1 GROUP BY id_degut ORDER BY "+ ordre, null);
        return c;
    }


    public static Cursor getQtyPagament(SQLiteDatabase db, Uri contactUri, String ordre) {   //Métode per a trobar la quantitat  deguda per un usuari en un deute concret

        String id_contact=null;
        Cursor id_cursor;
        id_cursor=getIdUser(db,contactUri);

        for(id_cursor.moveToFirst(); !id_cursor.isAfterLast(); id_cursor.moveToNext()) {
            id_contact = id_cursor.getString(0);

        }


        Cursor c = db.rawQuery("SELECT  SUM(Quantitat) FROM Deute1a1 WHERE id_degut = " + id_contact +
                " AND deutor=2 AND Estat=1 GROUP BY id_degut ORDER BY "+ ordre, null);
        return c;
    }





    public static Cursor getDeutes1a1(SQLiteDatabase db, Integer deutor, String Id_degut, String ordre2){       //Métode que retorna l'ID de deute segons els paràmetres

        Cursor c = db.rawQuery(" SELECT _Id FROM Deute1a1 WHERE Estat=1 AND deutor=" + deutor + " AND Id_degut="
                +Id_degut + " ORDER BY " + ordre2, null);


        return c;

    }
    public static Cursor getDeutes1a1Pagament(SQLiteDatabase db, Integer deutor, String Id_degut, String ordre2){   //Métode que retorna l'ID del pagament segons els paràmetres

        Cursor c = db.rawQuery(" SELECT _Id FROM Deute1a1 WHERE Estat=1 AND deutor=2 AND Id_degut="
                +Id_degut + " ORDER BY " + ordre2, null);


        return c;

    }
    public static Cursor getConcepteD1a1(SQLiteDatabase db, String IDDeute) {       //Métode que retorna el concepte d'un deute "1 a 1"

        Cursor c = db.rawQuery("SELECT Concepte FROM Deute1a1 WHERE _Id="+IDDeute,null);
        return c;
    }

    public static Cursor getQuantitatD1a1(SQLiteDatabase db, String IDDeute) {      //Métode que retorna la quantitat d'un deute "1 a 1"

        Cursor c = db.rawQuery("SELECT Quantitat FROM Deute1a1 WHERE _Id="+IDDeute,null);
        return c;
    }

    public static Cursor  getDataIniD1a1(SQLiteDatabase db, String IDDeute) {       //Métode que retorna la data d'inici d'un deute "1 a 1"

        Cursor c = db.rawQuery("SELECT Data_inici FROM Deute1a1 WHERE _Id="+IDDeute,null);
        return c;
    }

    public static Cursor  getDataFiD1a1(SQLiteDatabase db, String IDDeute) {        //Métode que retorna el la data de finalització d'un deute "1 a 1"

        Cursor c = db.rawQuery("SELECT Data_Fi FROM Deute1a1 WHERE _Id=" + IDDeute,null);
        return c;
    }

    public static Cursor  getDataIniGrups(SQLiteDatabase db, String IDDeute) {      //Métode que retorna la data d'inici d'un deute de grup

        Cursor c = db.rawQuery("SELECT Data_inici FROM Grups WHERE _Id="+IDDeute,null);
        return c;
    }
    public static Cursor  getDataFiGrups(SQLiteDatabase db, String IDDeute) {       //Métode que retorna la data de fi d'un deute de grup

        Cursor c = db.rawQuery("SELECT Data_Fi FROM Grups WHERE _Id="+IDDeute,null);
        return c;
    }



    public static Cursor  getDUserD1a1(SQLiteDatabase db, Integer IDDeute) {        //Retorna l'ID d'usuari d'un deute

        Cursor c = db.rawQuery("SELECT Id_degut FROM Deute1a1 WHERE _Id="+IDDeute,null);
        return c;
    }

    public static void updateDeuteGrup (SQLiteDatabase db, String iddeute,String Deute ) {  //Métode per actualitzar dades d'un deute individual dins d'un grup


        ContentValues con = new ContentValues();

        con.put("Quantitat", Deute);


        db.update("DeuteGrup", con, "_Id ='" + iddeute  + "'",null);

    }

    public static void updateGrup (SQLiteDatabase db, String IdGrup, String Nom, String Concepte, String Total ) {      //Métode per actualitzar dades d'un grup


        ContentValues con = new ContentValues();
        con.put("Nom", Nom);
        con.put("Concepte", Concepte);
        con.put("total", Total);


        db.update("Grups", con, "_Id ='" + IdGrup  + "'",null);

    }

    public static void  updatesaldadeutegrup (SQLiteDatabase db, String deute ) {       //Métode per actualitzar dades d'un deute d'un grup, donant-lo de baixa - estat=2


        ContentValues con = new ContentValues();
        SimpleDateFormat s = new SimpleDateFormat("dd-MM-yyyy hh:mm a");
        String formatData = s.format(new Date());
        con.put("estat", 2);
        con.put("Data_fi",formatData.toString());

        db.update("Grups", con, "_Id ='" + deute  + "'",null);


    }




    public static void  updatesaldadeuteuser (SQLiteDatabase db, String deute ) {       //Métode per actualitzar dades d'un deute d'un usuari d'un grup, donant-lo de baixa - estat=2


        ContentValues con = new ContentValues();

        con.put("Estat", 2);


        db.update("DeuteGrup", con, "_Id ='" + deute + "'", null);

    }






    public static void updatepagaGrup (SQLiteDatabase db, String iddeute,String qty ) {     //Métode per actualitzar dades d'un  grup, cambiant la quantitat


        ContentValues con = new ContentValues();

        con.put("total", qty);


        db.update("Grups", con, "_Id ='" + iddeute  + "'",null);

    }






    public static void updateDeute1a1 (SQLiteDatabase db, String[] Dades, String iddeute) {     //Métode per actualitzar dades d'un deute d'un deute 1 a 1
        String Concepte = Dades[0];
        String Quantitat = Dades[1];
        String Estat = Dades[2];
        SimpleDateFormat s = new SimpleDateFormat("dd-MM-yyyy hh:mm a");
        String formatData = s.format(new Date());

        ContentValues con = new ContentValues();

        con.put("concepte", Concepte);
        con.put("Quantitat", Quantitat);
        con.put("Estat", Estat);
        con.put("Data_Fi", formatData.toString());

        db.update("Deute1a1", con, "_Id ='" + iddeute  + "'",null);

    }

    public static Cursor getDadesDeuta1a1byID(SQLiteDatabase db) {       //Métode per obtenir dades d'un deute d'un deute 1 a 1

        Cursor c = db.rawQuery("SELECT  _Id FROM  Deute1a1  WHERE Estat = 1 AND deutor=1", null);

        return c;
    }
    public static Cursor getDadesHGrups(SQLiteDatabase db) {        //Métode per obtenir dades per al llistat d'històric de grups.

        Cursor c = db.rawQuery("SELECT  * FROM Grups WHERE Estat=2 ORDER BY Data_FI DESC LIMIT 10;", null);

        return c;
    }



    public static String getPagaTotal(SQLiteDatabase db) {      //Métode per extreure el "pendent de pagar" total
        String total = "0";

        Cursor c = db.rawQuery("SELECT SUM(Quantitat) FROM Deute1a1 WHERE deutor=2 AND Estat=1;",null);

        if(c.moveToFirst()){
            if(c.getString(0)!=null) {
                total = c.getString(0);
            }
        }

        return total;
    }

    public static String getCobraTotal(SQLiteDatabase db) {     //Métode per extreure el "pendent de cobrar" total
        String total = "0";

        Cursor c1 = db.rawQuery("SELECT SUM(Quantitat) FROM Deute1a1 WHERE deutor=1 AND Estat=1;",null);
        if (c1.moveToFirst()){
            if(c1.getString(0)!=null) {
                total = c1.getString(0);
            }
        }
        //Sumo, si existeixen, els deutes de grup i els unitaris (1 a 1)
        Cursor c2 = db.rawQuery("SELECT SUM(Total) FROM  Grups  WHERE Estat=1;",null);

        if (c2.moveToFirst()){
            if (c2.getString(0)!=null) {
                total = String.valueOf(Float.valueOf(total) + Float.valueOf(c2.getString(0)));
            }
        }


        return total;
    }




}