package com.buenodev.tests.debtoid_pruebas;
/*
/Aquesta obra esta subjecta a una licencia de Reconeixement-NoComercial-SenseObraDerivada 3.0 Espanya de Creative Commons
/
/
*/
//Classe per a editar cada usuari d'un grup
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.support.v7.app.ActionBarActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;


public class EditUserGrup extends ActionBarActivity {

    private static TextView textcontacte;
    private static TextView textGrup;
    private static TextView textconcepte;
    private static EditText editdeute;
    private static ImageView imgcontacte;
    private static Button notibutton;
    private static Button savebutton;
    private static Button saldarbutton;
    private static String quanti;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_edit_user_grup);

        textcontacte = (TextView) findViewById(R.id.textContact);
        textGrup = (TextView) findViewById(R.id.textGrup);
        textconcepte = (TextView) findViewById(R.id.TextConcepte);
        editdeute = (EditText) findViewById(R.id.TextQuantitat);
        imgcontacte = (ImageView) findViewById(R.id.imageContact);
        notibutton = (Button) findViewById(R.id.Notibutton);
        savebutton = (Button) findViewById(R.id.Savebutton);
        saldarbutton = (Button) findViewById(R.id.Paybutton);
        Bundle bundle = this.getIntent().getExtras();
        //Id_Deute: ID del GRUP del deute que tractem
        final String Id_Deute = bundle.getString("ID");
        //pos es la posició al cursor, ens diu quin és el deute segons la posició en el vector
        String pos = bundle.getString("pos");


        final DebtoidDBOpenHelper usdbh =
                new DebtoidDBOpenHelper(this, "DBDebtoid", null, 1);
        final SQLiteDatabase db = usdbh.getWritableDatabase();  //variable amb la base de dades


        final Cursor c = DebtoidDBOpenHelper.getcontactsperDeuteGrup(db, Id_Deute);
        c.moveToPosition(Integer.parseInt(pos));
        final String Iddeute = c.getString(0);        //ID del deute
        String IDUsr = c.getString(2);         //ID de l'usuari

        Context context = this.getApplicationContext();

        Cursor uriuser = DebtoidDBOpenHelper.getURiUserbyID(db, IDUsr);
        uriuser.moveToFirst();
        String useruri = uriuser.getString(0);      //URI de l'usuari del que mostrem les dades
        //Afegim les dades de l'usuari del grup
        textcontacte.setText(ContactMet.getName(useruri, context));
        imgcontacte.setImageBitmap(ContactMet.getPhoto(useruri, context));
        //Afegim les dades del grup
        Cursor cc = DebtoidDBOpenHelper.getNomGrup(db, Id_Deute);
        cc.moveToFirst();
        textGrup.setText(cc.getString(0));
        Cursor ccc = DebtoidDBOpenHelper.getConcepteGrup(db, Id_Deute);
        ccc.moveToFirst();
        textconcepte.setText(ccc.getString(0));
        quanti = c.getString(3);
        editdeute.setText(quanti);

        //Butó per a guardar canvis
        savebutton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {


                if (editdeute.getText().toString().isEmpty() || Float.valueOf(editdeute.getText().toString()) <= 0) {
                    cridatoast(getApplication());
                } else {

                    AlertDialog.Builder alertDialog = new AlertDialog.Builder(EditUserGrup.this);

                       alertDialog.setTitle("Confirmar actualització");

                    alertDialog.setMessage("Vols actualitzar el deute?");

                    alertDialog.setPositiveButton("Sí", new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int which) {
                            Cursor q = DebtoidDBOpenHelper.getQuantitatGrups(db, Id_Deute);
                            q.moveToFirst();
                            if (Float.valueOf(q.getString(0)) <= Float.valueOf(editdeute.getText().toString())) {       //comprobació de que l'usuari no té un deute major que el del grup
                                Toast toast0 =

                                        Toast.makeText(getApplication(),
                                                "El deute del grup és de " + q.getString(0) + ", no es pot pagar més del deute",
                                                Toast.LENGTH_LONG);
                                toast0.show();
                            } else {
                                DebtoidDBOpenHelper.updateDeuteGrup(db, Iddeute, editdeute.getText().toString());
                                Intent intent =
                                        new Intent(EditUserGrup.this, Grups_Activity.class)
                                                .addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                                startActivity(intent);
                                finish();
                            }

                        }
                    });

                    alertDialog.setNegativeButton("No", new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int which) {
                             Toast.makeText(getApplicationContext(), "No s'ha actualitzat el deute", Toast.LENGTH_SHORT).show();
                            dialog.cancel();
                        }
                    });
                    alertDialog.show();
                }
            }


        });

//Butó per saldar el deute de l'usuari (però no el del grup)
        saldarbutton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {


                if (editdeute.getText().toString().isEmpty() || Float.valueOf(editdeute.getText().toString()) <= 0) {
                    cridatoast(getApplication());
                } else {
                    AlertDialog.Builder alertDialog = new AlertDialog.Builder(EditUserGrup.this);
                    alertDialog.setTitle("Confirmar actualització");
                    alertDialog.setMessage("Vols eliminar el deute? Es restarà la quantitat del total del grup");

                      alertDialog.setPositiveButton("Sí", new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int which) {
                            Cursor q = DebtoidDBOpenHelper.getQuantitatGrups(db, Id_Deute);
                            q.moveToFirst();
                            if (Float.valueOf(q.getString(0)) <= Float.valueOf(editdeute.getText().toString())) {
                                Toast toast0 =
                                        Toast.makeText(getApplication(),
                                                "Aquesta acció eliminaria el grup, has de donar el grup per saldat a la pantalla de grups ",
                                                Toast.LENGTH_LONG);
                                toast0.show();
                            } else {
                                Float quantitatgrup = Float.valueOf(q.getString(0));
                                quantitatgrup = quantitatgrup - Float.valueOf(editdeute.getText().toString());
                                DebtoidDBOpenHelper.updatepagaGrup(db, Id_Deute, quantitatgrup.toString());         //Actualizo el grup
                                DebtoidDBOpenHelper.updatesaldadeuteuser(db, Iddeute);                              //Dono com a saldat a la base de dades el deute


                                Intent intent =
                                        new Intent(EditUserGrup.this, Grups_Activity.class)
                                                .addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                                startActivity(intent);
                                finish();

                            }
                        }
                    });

                    alertDialog.setNegativeButton("No", new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int which) {
                             Toast.makeText(getApplicationContext(), "No s'ha actualitzat el deute", Toast.LENGTH_SHORT).show();
                            dialog.cancel();
                        }
                    });
                    alertDialog.show();


                }
            }


        });

        //butó per enviar notificació per whatsapp
        notibutton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                PackageManager pm = getPackageManager();
                try {

                    Intent waIntent = new Intent(Intent.ACTION_SEND);
                    waIntent.setType("text/plain");
                    String text = "---Enviat des de DEBTOID--- Recordatori de deuta:" +
                            " " + editdeute.getText() + " en concepte de deute de grup  " +
                            textGrup.getText() + " - " + textconcepte.getText();

                    PackageInfo info = pm.getPackageInfo("com.whatsapp", PackageManager.GET_META_DATA);
                    waIntent.setPackage("com.whatsapp");

                    waIntent.putExtra(Intent.EXTRA_TEXT, text);
                    startActivity(Intent.createChooser(waIntent, "Share with"));

                } catch (PackageManager.NameNotFoundException e) {
                    Toast.makeText(getApplication(), "WhatsApp no Instal-lat", Toast.LENGTH_SHORT)
                            .show();
                }

            }

        });

    }


    private static void cridatoast(Context context) {    //Métode per a mostrar avís de que el valor del deute ha d'existir i ser diferent de 0
        Toast toast1 =

                Toast.makeText(context,
                        "Has d'omplir el valor del deute, no pot ser igual a zero ",
                        Toast.LENGTH_LONG);
        toast1.show();
    }

    ;

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_edit_user_grup, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        //if (id == R.id.action_settings) {
        return true;
        //}

        // return super.onOptionsItemSelected(item);
    }
}
