package com.buenodev.tests.debtoid_pruebas;
/*
/Aquesta obra esta subjecta a una licencia de Reconeixement-NoComercial-SenseObraDerivada 3.0 Espanya de Creative Commons
/
/
*/

import android.annotation.TargetApi;
import android.content.Intent;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Build;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.support.v7.app.ActionBarActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.ListView;

import java.util.ArrayList;

public class Grups_Activity extends ActionBarActivity {
    private Button NouGrupButton;
    ListView listView;
    ArrayList<GrupsMet> listaGrups;
    AdapterGrups adapter;

    @Override

    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_grups);
        NouGrupButton = (Button) findViewById(R.id.NouGrupButton);
        listView = (ListView) findViewById(R.id.listView);
        listaGrups = new ArrayList<GrupsMet>();


        //Obrim la base de dades 'DBUsuarios' en mode escritura per trobar els grups que ja tenim creats
        final DebtoidDBOpenHelper usdbh =
                new DebtoidDBOpenHelper(this, "DBDebtoid", null, 1);

        final SQLiteDatabase db = usdbh.getWritableDatabase();

        SharedPreferences pref =
                PreferenceManager.getDefaultSharedPreferences(this);
        String ordre = pref.getString("opciordre", "");
        switch (ordre) {
            case "":
                ordre = "Total ASC";
                break;
            case "1":
                ordre = "Total ASC";
                break;
            case "2":
                ordre = "Total DESC";
                break;
            case "3":
                ordre = "Data_inici ASC";
                break;
            case "4":
                ordre = "Data_inici DESC";
                break;
        }

//Afegim a la listview les dades extretes de la base de dades, utilitzant l'adapter
        final Cursor cur = DebtoidDBOpenHelper.getDadesCobramentGrups(db, ordre);

        for (cur.moveToFirst(); !cur.isAfterLast(); cur.moveToNext()) {
            listaGrups.add(new GrupsMet(cur.getString(0)));

        }

        adapter = new AdapterGrups(this, listaGrups);
        listView.setAdapter(adapter);
        adapter.notifyDataSetChanged();

        NouGrupButton = (Button) findViewById(R.id.NouGrupButton);
//But per a cridar a l'activitat que ens permet crear un altre grup
        NouGrupButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent =
                        new Intent(Grups_Activity.this, NouGrup_Activity.class)
                                .addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                startActivity(intent);
                finish();
            }
        });
//Listener per tal de seleccionar el grup a editar
        listView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @TargetApi(Build.VERSION_CODES.JELLY_BEAN)
            public void onItemClick(AdapterView<?> parent, View view,
                                    int position, long id) {

                Integer posicion = position;
                String posicion2 = posicion.toString();

                Bundle b = new Bundle();
                b.putString("ID", posicion2);
                b.putString("IDvector","..");
                Intent intent =
                        new Intent(Grups_Activity.this, EditGrup_Activity.class).addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                intent.putExtras(b);
                startActivity(intent, b);
                finish();
            }
        });
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_cobraments, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        //  if (id == R.id.action_settings) {
        return true;
        //  }

        //   return super.onOptionsItemSelected(item);
    }


}