package com.buenodev.tests.debtoid_pruebas;
/*
/Aquesta obra esta subjecta a una licencia de Reconeixement-NoComercial-SenseObraDerivada 3.0 Espanya de Creative Commons
/
/
*/
/*
Activitat principal de l'aplicació. Des d'aquesta activity podem accedir a la resta
 */
import android.content.ComponentName;
import android.content.Intent;
import android.content.SharedPreferences;
import android.database.sqlite.SQLiteDatabase;
import android.preference.PreferenceManager;
import android.support.v7.app.ActionBarActivity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.ImageButton;
import android.widget.TextView;
import android.widget.Toast;


public class MainActivity extends ActionBarActivity implements SharedPreferences.OnSharedPreferenceChangeListener {

    //Declaro les variables que utilitzaré
    private ImageButton btnGrups;
    private ImageButton btnAlarmes;
    private ImageButton btnPagaments;
    private ImageButton btnInfo;
    private ImageButton btnCobraments;
    private ImageButton btnPreferencies;
    private ImageButton btnResum;
    private SQLiteDatabase db;

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
//Crido els controls de la vista associada

//Obro la base de dades per fer consultes i/o introduïr valors

        DebtoidDBOpenHelper usdbh =
                new DebtoidDBOpenHelper(this, "DBDebtoid", null, 1);

        final SQLiteDatabase db = usdbh.getWritableDatabase();

        TextView TextDeus = (TextView) findViewById(R.id.TextDeus);
        TextView TextDec = (TextView)findViewById(R.id.TextDec);
        btnGrups = (ImageButton) findViewById(R.id.buttonGrups);
        btnAlarmes = (ImageButton) findViewById(R.id.buttonAlarmes);
        btnPagaments = (ImageButton) findViewById(R.id.buttonPagaments);
        btnInfo = (ImageButton) findViewById(R.id.buttonInfo);
        btnCobraments = (ImageButton) findViewById(R.id.buttonCobraments);
        btnPreferencies = (ImageButton) findViewById(R.id.buttonPreferencies);
        btnResum = (ImageButton) findViewById(R.id.buttonResum);
        SharedPreferences pref =
                PreferenceManager.getDefaultSharedPreferences(this);
        String  money = pref.getString("opciomoneda", "");
        switch (money){
            case "":
                money = "€";
                break;
            case "1":
                money = "€";
                break;
            case "2":
                money = "$";
                break;
            case "3":
                money = "£";
                break;
        }
        //Carrego les dades extretes d'una consulta a la base de dades per tenir la suma total del deute i del que es deu
        pref.registerOnSharedPreferenceChangeListener(this);
        TextDeus.setText("Deus en total: " + DebtoidDBOpenHelper.getPagaTotal(db) + " " + money);
        TextDec.setText("Se't deu en total: " + DebtoidDBOpenHelper.getCobraTotal(db)+" " +money);

        //Declaro les diferents crides als diferents apartats de l'aplicació

        btnGrups.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                Intent intent =
                        new Intent(MainActivity.this, Grups_Activity.class).addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                startActivity(intent);

            }


        });
        btnAlarmes.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {


                Intent i= new Intent(Intent.ACTION_VIEW); i.setClassName("com.android.calendar", "com.android.calendar.LaunchActivity"); startActivity(i);

            }
        });

        btnPagaments.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                Intent intent =
                        new Intent(MainActivity.this, Pagaments_Activity.class).addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                startActivity(intent);

            }


        });

        btnInfo.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                Intent intent =
                        new Intent(MainActivity.this, Sobre_Activity.class);
                startActivity(intent);

            }


        });

        btnCobraments.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                Intent intent =
                        new Intent(MainActivity.this, Cobraments_Activity.class).addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                startActivity(intent);
            }


        });

        btnPreferencies.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                Intent intent =
                        new Intent(MainActivity.this, Preferencies_Activity.class);
                startActivity(intent);
            }


        });

        btnResum.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                Intent intent =
                        new Intent(MainActivity.this, Resum_Activity.class);
                startActivity(intent);
            }


        });

    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
       // if (id == R.id.action_settings) {
            return true;
     //   }

     //   return super.onOptionsItemSelected(item);
    }



    @Override
    public void onSharedPreferenceChanged(SharedPreferences sharedPreferences, String key) {  //Procediment per a canviar dades i recarregar en funció de les preferéncies escollides.
    if (key.equals("opciomoneda")) {
        DebtoidDBOpenHelper usdbh =
                new DebtoidDBOpenHelper(this, "DBDebtoid", null, 1);

        final SQLiteDatabase db = usdbh.getWritableDatabase();


        SharedPreferences pref =
                PreferenceManager.getDefaultSharedPreferences(this);
        pref.registerOnSharedPreferenceChangeListener(this);
        String  money = pref.getString("opciomoneda", "");
        switch (money){
            case "1":
                money = "€";
                break;
            case "2":
                money = "$";
                break;
            case "3":
                money = "£";
                break;
        }

        TextView TextDeus = (TextView) findViewById(R.id.TextDeus);

        TextView TextDec = (TextView) findViewById(R.id.TextDec);

        TextDeus.setText("Deus en total: " + DebtoidDBOpenHelper.getPagaTotal(db) + " " + money);
        TextDec.setText("Se't deu en total: " + DebtoidDBOpenHelper.getCobraTotal(db)+" " +money);

    }else   if (key.equals("opciordre")){
        SharedPreferences pref =
                PreferenceManager.getDefaultSharedPreferences(this);
        pref.registerOnSharedPreferenceChangeListener(this);
            String  ordre = pref.getString("opciordre", "");

            switch (ordre){

                case "1":
                    ordre = "1";
                    break;
                case "2":
                    ordre = "2";
                    break;
                case "3":
                    ordre = "3";
                    break;
                case "4":
                    ordre = "4";
                    break;
            }
        }

    }


    @Override
    protected void onResume()
    {
        super.onResume();

        DebtoidDBOpenHelper usdbh =
                new DebtoidDBOpenHelper(this, "DBDebtoid", null, 1);

        final SQLiteDatabase db = usdbh.getWritableDatabase();

        TextView TextDeus = (TextView) findViewById(R.id.TextDeus);
        TextView TextDec = (TextView)findViewById(R.id.TextDec);
        btnGrups = (ImageButton) findViewById(R.id.buttonGrups);
        btnAlarmes = (ImageButton) findViewById(R.id.buttonAlarmes);
        btnPagaments = (ImageButton) findViewById(R.id.buttonPagaments);
        btnInfo = (ImageButton) findViewById(R.id.buttonInfo);
        btnCobraments = (ImageButton) findViewById(R.id.buttonCobraments);
        btnPreferencies = (ImageButton) findViewById(R.id.buttonPreferencies);
        btnResum = (ImageButton) findViewById(R.id.buttonResum);
        SharedPreferences pref =
                PreferenceManager.getDefaultSharedPreferences(this);
        String  money = pref.getString("opciomoneda", "");
        switch (money){
            case "":
                money = "€";
                break;
            case "1":
                money = "€";
                break;
            case "2":
                money = "$";
                break;
            case "3":
                money = "£";
                break;
        }
        //Carrego les dades extretes d'una consulta a la base de dades per tenir la suma total del deute i del que es deu
        pref.registerOnSharedPreferenceChangeListener(this);
        TextDeus.setText("Deus en total: " + DebtoidDBOpenHelper.getPagaTotal(db) + " " + money);
        TextDec.setText("Se't deu en total: " + DebtoidDBOpenHelper.getCobraTotal(db)+" " +money);



    }

}
