package com.buenodev.tests.debtoid_pruebas;
/*
/Aquesta obra esta subjecta a una licencia de Reconeixement-NoComercial-SenseObraDerivada 3.0 Espanya de Creative Commons
/
/
*/

import android.app.AlertDialog;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.net.Uri;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.support.v4.app.DialogFragment;
import android.support.v4.app.FragmentManager;
import android.support.v7.app.ActionBarActivity;
import android.util.Log;
import android.view.Gravity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;


public class NouGrup_Activity extends ActionBarActivity {
    public static final int PICK_CONTACT_REQUEST = 1;
    private static Uri contactUri;
    private static EditText total;
    private static EditText TextNom;
    private static EditText TextConcepte;
    private static EditText TextTotal;
    private Button AfegirCont;
    private Button saveButton;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_nou_grup);
        saveButton = (Button) findViewById(R.id.Savebutton);
        TextNom = (EditText) findViewById(R.id.TextNom);
        TextConcepte = (EditText) findViewById(R.id.TextConcepte);
        TextTotal = (EditText) findViewById((R.id.TextTotal));
        final DebtoidDBOpenHelper usdbh =
                new DebtoidDBOpenHelper(this, "DBDebtoid", null, 1);
        final SQLiteDatabase db = usdbh.getWritableDatabase();  //variable amb la base de dades
        // Butó per emmagatzemar a la base de dades
        saveButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                // En aquest cas no importa si l'usuari ha afegit o no usuaris, ja que els pot
                // afegir després,però sí que volem tenir la resta de dades per tal de crear el grup.
                if (TextNom.getText().toString().isEmpty() || TextConcepte.getText().toString().isEmpty() || TextTotal.getText().toString().isEmpty()) {
                    Toast toast1 =
                            Toast.makeText(getApplicationContext(),
                                    "Has d'omplir totes les dades ",        //Missatge d'error en cas de no haver introduït tots els paràmetres requerits
                                    Toast.LENGTH_LONG);
                    toast1.setGravity(Gravity.CENTER_VERTICAL, 0, 0);
                    toast1.show();
                } else {
                    //Crida a missatge de confirmació per continuar el procés
                    FragmentManager fragmentManager = getSupportFragmentManager();
                    DialogoConfirmacion dialogo = new DialogoConfirmacion();
                    dialogo.show(fragmentManager, "tagAlerta");
                }
            }
        });

    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_nou_grup_, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();
        //noinspection SimplifiableIfStatement
        // if (id == R.id.action_settings) {
        return true;
        // }
        // return super.onOptionsItemSelected(item);
    }

    public static class DialogoConfirmacion extends DialogFragment {       //Establim el diàlog de confirmació
        @Override
        public Dialog onCreateDialog(Bundle savedInstanceState) {
            final Context context = null;
            SharedPreferences pref =
                    PreferenceManager.getDefaultSharedPreferences(getActivity());
            String money = pref.getString("opciomoneda", "");
            switch (money) {
                case "":
                    money = "€";
                    break;
                case "1":
                    money = "€";
                    break;
                case "2":
                    money = "$";
                    break;
                case "3":
                    money = "£";
                    break;
            }
            AlertDialog.Builder builder =
                    new AlertDialog.Builder(getActivity());
            builder.setMessage("Confirmar el grup següent: " + TextNom.getText() + " en Concepte de "
                    + TextConcepte.getText().toString() +" " + money)
                    .setTitle("D'acord")
                    .setPositiveButton("Acceptar", new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int id) {
                            Log.i("Dialogos", "Confirmació Acceptada.");
                            dialog.cancel();
                            //Tornem a declarar la base de dades per fer-ne ús
                            final DebtoidDBOpenHelper usdbh =
                                    new DebtoidDBOpenHelper(getActivity().getBaseContext(), "DBDebtoid", null, 1);
                            final SQLiteDatabase db = usdbh.getWritableDatabase();
                            DebtoidDBOpenHelper.insertarGrups(db, TextNom.getText().toString(), TextConcepte.getText().toString(), TextTotal.getText().toString());
                            Cursor ins = DebtoidDBOpenHelper.getDadesCobramentGrups(db, "_Id");
                            String ins2 = String.valueOf(ins.getCount() - 1);
                            //Bundle put "ID" (últim del vector)
                            Bundle b = new Bundle();
                            b.putString("IDvector", String.valueOf(ins2));
                            Intent intent =
                                    new Intent(getActivity(), EditGrup_Activity.class).addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                            intent.putExtras(b);
                            startActivity(intent);
                            getActivity().finish();
                        }
                    })
                    .setNegativeButton("Cancel-lar", new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int id) {
                            Log.i("Dialogos", "Confirmació Cancel-lada");
                            dialog.cancel();
                        }
                    });
            return builder.create();
        }
    }
}
