package com.buenodev.tests.debtoid_pruebas;
/*
/Aquesta obra esta subjecta a una licencia de Reconeixement-NoComercial-SenseObraDerivada 3.0 Espanya de Creative Commons
/
/
*/
/*
Mitjançant aquesta Activity es pot crear un nou pagament
 */

import android.app.AlertDialog;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.net.Uri;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.provider.ContactsContract;
import android.support.v4.app.DialogFragment;
import android.support.v4.app.FragmentManager;
import android.support.v7.app.ActionBarActivity;
import android.util.Log;
import android.view.Gravity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;


public class NouPagamentActivity extends ActionBarActivity {


    //Declaro les variables que utilitzaré
    public static final int PICK_CONTACT_REQUEST = 1;
    private static Uri contactUri = null;
    private static TextView contactText;
    private ImageView imageContact;
    private Button AfegirCont;
    public static EditText Concept;
    public static EditText Quantitat;
    private Button saveButton;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_nou_pagament);
        //Crido els controls de la vista associada
        contactText = (TextView) findViewById(R.id.textView);
        AfegirCont = (Button) findViewById((R.id.afegirUs));
        imageContact = (ImageView) findViewById(R.id.imageContact);
        Concept = (EditText) findViewById(R.id.TextConcepte);
        Quantitat = (EditText) findViewById(R.id.TextQuantitat);
        saveButton = (Button) findViewById(R.id.Savebutton);
        //Obro la base de dades per fer consultes i/o introduïr valors
        final DebtoidDBOpenHelper usdbh =
                new DebtoidDBOpenHelper(this, "DBDebtoid", null, 1);
        final SQLiteDatabase db = usdbh.getWritableDatabase();  //variable amb la base de dades
        // Butó per emmagatzemar a la base de dades
        saveButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //comprovació de que s'hagi introduït el contacte i hi hagi un concepte i quantitat per emmagatzemar
                if (contactUri == null || Concept.getText().toString().isEmpty() || Quantitat.getText().toString().isEmpty()) {
                    Toast toast1 =
                            Toast.makeText(getApplicationContext(),
                                    "Has d'omplir totes les dades ",        //Missatge d'error en cas de no haver introduït tots els paràmetres requerits
                                    Toast.LENGTH_LONG);
                    toast1.setGravity(Gravity.CENTER_VERTICAL, 0, 0);
                    toast1.show();
                } else {
                    //Crida a missatge de confirmació per continuar el procés
                    FragmentManager fragmentManager = getSupportFragmentManager();
                    DialogoConfirmacion dialogo = new DialogoConfirmacion();
                    dialogo.show(fragmentManager, "tagAlerta");
                }
            }
        });
    }


    public void initPickContacts(View v) {      //Métode que ens torna l'usuari seleccionat de la memòria del teléfon
        // Intent per seleccionar contacte
        Intent i = new Intent(Intent.ACTION_PICK, ContactsContract.Contacts.CONTENT_URI);
        //       Iniciar la actividat esperant resposta  mitjançant el canal PICK_CONTACT_REQUEST
        startActivityForResult(i, PICK_CONTACT_REQUEST);
    }

    protected void onActivityResult(int requestCode, int resultCode, Intent intent) {       //Al rebre resultat del diàleg de confirmació...

        super.onActivityResult(requestCode, resultCode, intent);
        if (requestCode == PICK_CONTACT_REQUEST) {
            if (resultCode == RESULT_OK) {
                //Capturar el valor de la Uri
                contactUri = intent.getData();
                //Processar la Uri
                Context context = this.getApplicationContext();
                contactText.setText(ContactMet.getName(contactUri.toString(), context));            //Mitjançant la Uri, tenim les dades del contacte
                imageContact.setImageBitmap(ContactMet.getPhoto(contactUri.toString(), context));
            }
        }
    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_nou_cobrament, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        // if (id == R.id.action_settings) {
        return true;
        // }

        //  return super.onOptionsItemSelected(item);
    }


    public static class DialogoConfirmacion extends DialogFragment {       //Establim el diàlog de confirmació
        @Override
        public Dialog onCreateDialog(Bundle savedInstanceState) {
            final Context context = null;
            SharedPreferences pref =
                    PreferenceManager.getDefaultSharedPreferences(getActivity());
            String money = pref.getString("opciomoneda", "");
            switch (money) {
                case "":
                    money = "€";
                    break;
                case "1":
                    money = "€";
                    break;
                case "2":
                    money = "$";
                    break;
                case "3":
                    money = "£";
                    break;
            }

            AlertDialog.Builder builder =
                    new AlertDialog.Builder(getActivity());
            builder.setMessage("Confirmar el pagament següent: " + contactText.getText() + " Concepte: "
                    + Concept.getText() + " Per valor de " + Quantitat.getText() + money)
                    .setTitle("D'acord")
                    .setPositiveButton("Acceptar", new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int id) {
                            Log.i("Dialogos", "Confirmació Acceptada.");
                            dialog.cancel();
                            //Tornem a declarar la base de dades per fer-ne ús
                            final DebtoidDBOpenHelper usdbh =
                                    new DebtoidDBOpenHelper(getActivity().getBaseContext(), "DBDebtoid", null, 1);
                            final SQLiteDatabase db = usdbh.getWritableDatabase();
                            DebtoidDBOpenHelper.insertarUsuari(db, contactUri);
                            Integer UserId = null;
                            final Cursor cur = DebtoidDBOpenHelper.getIdUser(db, contactUri);       //Trobem l'Id d'usuari de la base de dades a través de la Uri
                            for (cur.moveToFirst(); !cur.isAfterLast(); cur.moveToNext()) {
                                UserId = cur.getInt(0);
                            }
                            //A diferéncia de cobrament, el tipus de deutor és el 2.
                            DebtoidDBOpenHelper.insertDeute1a1(db, 2, UserId, Concept.getText().toString(), Quantitat.getText().toString());    //Inserim el deute
                            contactUri = null;
                            Intent intent =
                                    new Intent(getActivity(), Pagaments_Activity.class)
                                            .addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);//Tornem al menú principal de cobraments.
                            startActivity(intent);
                            getActivity().finish();

                        }
                    })
                    .setNegativeButton("Cancel-lar", new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int id) {
                            Log.i("Dialogos", "Confirmació Cancel-lada");
                            dialog.cancel();
                        }
                    });

            return builder.create();
        }
    }


}
