package com.buenodev.tests.debtoid_pruebas;

/*
/Aquesta obra esta subjecta a una licencia de Reconeixement-NoComercial-SenseObraDerivada 3.0 Espanya de Creative Commons
/
/
*/
//Aquesta classe permet editar un pagament per canviar la quantitat, saldar el deute o crear una notificació per whatsapp

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.support.v7.app.ActionBarActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;


public class PagamentEdit extends ActionBarActivity {
    TextView textContact;
    ImageView imageContact;
    EditText TextConcepte;
    EditText TextQuantitat;
    Button savebutton;
    Button notibutton;
    Button paybutton;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_pagament_edit);

        textContact = (TextView) findViewById(R.id.textContact);
        imageContact = (ImageView) findViewById(R.id.imageContact);
        TextConcepte = (EditText) findViewById(R.id.TextConcepte);
        TextQuantitat = (EditText) findViewById(R.id.TextQuantitat);
        savebutton = (Button) findViewById(R.id.Savebutton);
        notibutton = (Button) findViewById(R.id.Notibutton);
        paybutton = (Button) findViewById(R.id.Paybutton);
        //Extrec de l'activitat anterior les dades necessàries per fer consultes a la base de dades
        Bundle bundle = this.getIntent().getExtras();
        String Id_Deute = bundle.getString("ID");
        String ID_Usr = bundle.getString("IDUsr");

        final Context context = this.getApplicationContext();
        String Deute = null;
        DebtoidDBOpenHelper usdbh =
                new DebtoidDBOpenHelper(this, "DBDebtoid", null, 1);
        final SQLiteDatabase db = usdbh.getWritableDatabase();
        //Trobo l'usuari i carrego les seves dades, nom i imatge

        String Usuari = null;
        Cursor c = DebtoidDBOpenHelper.getURiUserbyID(db, ID_Usr);
        c.moveToFirst();
        Usuari = c.getString(0);
        textContact.setText(ContactMet.getName(Usuari, context));
        imageContact.setImageBitmap(ContactMet.getPhoto(Usuari, context));


        String ID_Deute = null;

        SharedPreferences pref =
                PreferenceManager.getDefaultSharedPreferences(this);
        //Trobo l'ordre per a  consultar el deute
        String ordre = pref.getString("opciordre", "");
        String ordre2 = ordre;
        switch (ordre) {
            case "":
                ordre = "SUM(Quantitat) ASC";
                ordre2 = "Quantitat ASC";
                break;
            case "1":
                ordre = "SUM(Quantitat) ASC";
                ordre2 = "Quantitat ASC";
                break;
            case "2":
                ordre = "SUM(Quantitat) DESC";
                ordre2 = "Quantitat DESC";
                break;
            case "3":
                ordre = "Data_inici ASC";
                ordre2 = "Data_inici  ASC";
                break;
            case "4":
                ordre = "Data_inici DESC";
                ordre2 = "Data_inici  DESC";
                break;
        }
        Cursor cc = DebtoidDBOpenHelper.getDeutes1a1(db, 2, ID_Usr, ordre2);
        cc.moveToPosition(Integer.parseInt(Id_Deute));
        ID_Deute = cc.getString(0);
        Cursor cccc = DebtoidDBOpenHelper.getQuantitatD1a1(db, ID_Deute);
        cccc.moveToFirst();
        //Carrego la resta de dades del deute
        TextQuantitat.setText(cccc.getString(0));
        Cursor ccc = DebtoidDBOpenHelper.getConcepteD1a1(db, ID_Deute);
        ccc.moveToFirst();
        TextConcepte.setText(ccc.getString(0));
        final String finalDeute = ID_Deute;

        //Aquest butó permet emmagatzemar canvis en el nom, concepte o quantitat del pagament
        savebutton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (TextConcepte.getText().toString().isEmpty() || TextQuantitat.getText().toString().isEmpty()) {   //Comprobació de que els camps tinguin dades
                    Toast toast1 =
                            Toast.makeText(getApplicationContext(),
                                    "Has d'omplir totes les dades ",
                                    Toast.LENGTH_LONG);
                    toast1.show();
                } else {
                    final String[] Dades = {
                            TextConcepte.getText().toString(),
                            TextQuantitat.getText().toString(),
                            "1"
                    };

                    if (Float.compare(Float.parseFloat(Dades[1]), Float.parseFloat("0")) == 0) {  //Avís en cas de que la quantitat sigui 0.
                        Toast.makeText(context, "No existeixen els pagaments amb valor 0",
                                Toast.LENGTH_SHORT).show();
                    } else {
                        AlertDialog.Builder alertDialog = new AlertDialog.Builder(PagamentEdit.this);
                        alertDialog.setTitle("Confirmar actualització");
                        alertDialog.setMessage("Vols actualitzar el pagament?");
                        alertDialog.setPositiveButton("Sí", new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int which) {
                                DebtoidDBOpenHelper.updateDeute1a1(db, Dades, finalDeute);
                                Intent intent =
                                        new Intent(PagamentEdit.this, Cobraments_Activity.class)
                                                .addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                                startActivity(intent);
                                finish();
                            }
                        });

                        alertDialog.setNegativeButton("No", new DialogInterface.OnClickListener() {     //En cas de cancel-lar l'actualització, mostrem el missatge
                            public void onClick(DialogInterface dialog, int which) {
                                Toast.makeText(getApplicationContext(), "No s'ha actualitzat el pagament", Toast.LENGTH_SHORT).show();
                                dialog.cancel();
                            }
                        });
                        alertDialog.show();
                    }
                }
            }
        });

//Butó per a saldar el deute del pagament
        paybutton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (TextConcepte.getText().toString().isEmpty() || TextQuantitat.getText().toString().isEmpty()) {
                    Toast toast1 =
                            Toast.makeText(getApplicationContext(),
                                    "Has d'omplir totes les dades ",
                                    Toast.LENGTH_LONG);
                    toast1.show();
                } else {
                    AlertDialog.Builder alertDialog = new AlertDialog.Builder(PagamentEdit.this);
                    alertDialog.setTitle("Confirmar pagament");
                    alertDialog.setMessage("Confirmar el pagament");
                    alertDialog.setPositiveButton("Sí", new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int which) {

                            String[] Dades = {              //En cas d'acceptar el pagament, canviarem a la base de dades el seu estat al valor "2", amb el que donarem per saldat el deute.
                                    TextConcepte.getText().toString(),
                                    TextQuantitat.getText().toString(),
                                    "2"
                            };
                            DebtoidDBOpenHelper.updateDeute1a1(db, Dades, finalDeute);
                            Intent intent =
                                    new Intent(PagamentEdit.this, Cobraments_Activity.class)
                                            .addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                            startActivity(intent);
                            finish();
                        }
                    });

                    alertDialog.setNegativeButton("NO", new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int which) {
                            Toast.makeText(getApplicationContext(), "No s'ha acceptat", Toast.LENGTH_SHORT).show();
                            dialog.cancel();
                        }
                    });
                    alertDialog.show();
                }
            }
        });

        //Butó per enviar una notificació mitjançant Whatsapp - Degut al funcionament de Whatsapp no es pot enviar el missatge directament i s'ha de seleccionar

        notibutton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                PackageManager pm = getPackageManager();
                try {

                    Intent waIntent = new Intent(Intent.ACTION_SEND);
                    waIntent.setType("text/plain");
                    String text = "---Enviat des de DEBTOID--- Recordatori de pagament pendent:" +
                            " " + TextQuantitat.getText() + " en concepte de " +
                            TextConcepte.getText();

                    PackageInfo info = pm.getPackageInfo("com.whatsapp", PackageManager.GET_META_DATA);
                    waIntent.setPackage("com.whatsapp");
                    waIntent.putExtra(Intent.EXTRA_TEXT, text);
                    startActivity(Intent.createChooser(waIntent, "Share with"));
                } catch (PackageManager.NameNotFoundException e) {
                    Toast.makeText(context, "WhatsApp no instal-lat", Toast.LENGTH_SHORT)
                            .show();
                }
            }
        });
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_pagament_edit, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        //  if (id == R.id.action_settings) {
        return true;
    }
    //   return super.onOptionsItemSelected(item);
    //  }
}
