package com.buenodev.tests.debtoid_pruebas;

/*
/Aquesta obra esta subjecta a una licencia de Reconeixement-NoComercial-SenseObraDerivada 3.0 Espanya de Creative Commons
/
/
*/

/*
Aquesta activitat és l'arrel per a gestionar els pagaments pendents. El funcionament serà molt
semblant a cobraments. De fet els mètodes i funcions a implementar són gairebé iguals, però canviant
alguns paràmetres tenim dos tipus de deutes diferents: Els pagaments pendents en aquest cas, i els
cobraments, en un altre apartat
 */

import android.annotation.TargetApi;
import android.content.Intent;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Build;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.support.v7.app.ActionBarActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.ListView;

import java.util.ArrayList;

public class Pagaments_Activity extends ActionBarActivity {

    //Carrego la llista de pagaments pendents a un arraylist de tipus ContactMet definit a una altre
    //classe.

    ListView listView;
    ArrayList<ContactMet> listaContactos;
    AdapterContactPagament adapter;
    private Button nouPagament;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_pagaments);
        listView = (ListView) findViewById(R.id.listView);
        listaContactos = new ArrayList<ContactMet>();

        //Abrimos la base de datos 'DBUsuarios' en modo escritura
        final DebtoidDBOpenHelper usdbh =
                new DebtoidDBOpenHelper(this, "DBDebtoid", null, 1);

        final SQLiteDatabase db = usdbh.getWritableDatabase();
//Obtinc l'ordre per a fer consultes de les preferències
        SharedPreferences pref =
                PreferenceManager.getDefaultSharedPreferences(this);
        String ordre = pref.getString("opciordre", "");
        switch (ordre) {
            case "":
                ordre = "SUM(d.Quantitat) ASC";
                break;
            case "1":
                ordre = "SUM(d.Quantitat) ASC";
                break;
            case "2":
                ordre = "SUM(d.Quantitat) DESC";
                break;
            case "3":
                ordre = "d.Data_inici ASC";
                break;
            case "4":
                ordre = "d.Data_inici DESC";
                break;
        }
//Obtinc les dades dels pagaments des de la base de dades i mitjançant un cursor, les carrego a la
// llista fent servir un adapter
        final Cursor cur = DebtoidDBOpenHelper.getDadesPagament(db, ordre);

        for (cur.moveToFirst(); !cur.isAfterLast(); cur.moveToNext()) {
            listaContactos.add(new ContactMet(cur.getString(0)));
        }

        adapter = new AdapterContactPagament(this, listaContactos);
        listView.setAdapter(adapter);

        adapter.notifyDataSetChanged();

        nouPagament = (Button) findViewById(R.id.NouPagamentButton);
//Estableixo un "listener" per tal de poder cridar la activity de creació de pagaments
        nouPagament.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent =
                        new Intent(Pagaments_Activity.this, NouPagamentActivity.class)
                                .addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                startActivity(intent);
            }
        });
//Estableixo un "listener" per a la llista tal de poder cridar la activity de visualització de pagaments

        listView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @TargetApi(Build.VERSION_CODES.JELLY_BEAN)
            public void onItemClick(AdapterView<?> parent, View view,
                                    int position, long id) {

                Integer posicion = position;
                String posicion2 = posicion.toString();

                Bundle b = new Bundle();
                //afegeixo l'ID del pagament que vull veure
                b.putString("ID", posicion2);
                Intent intent =
                        new Intent(Pagaments_Activity.this, PagamentListView.class);
                intent.putExtras(b);
                startActivity(intent, b);
            }
        });
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_cobraments, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        //  if (id == R.id.action_settings) {
        return true;
        //  }

        // return super.onOptionsItemSelected(item);
    }
}




